#!/usr/bin/perl

################################################################
# Script/Program to read a user's tables and display the table #
# and column names and comments in a preformatted block, from  #
# a browser web page. The program dynamically builds the input #
# form, then displays the information.                         #
# (c)1996 Costello/Feynman Memorial Labs. All rights reserved. #
# Real (c)1996 scott beimer.                                   #
# author makes no warranties as to fitness or merchantability  #
# of the code. use at your own risk.                           #
################################################################

use Oci;
package Oci;
require "ociwrap.pl";

$date = `date +"%A, %B %d, %Y at %T (%Z)"`; chop($date);

$host = $ENV{'REMOTE_HOST'};
$host =~ s/\W.*//;
$dateline = "Requested by $host on $date\n";
$con_len = $ENV{'CONTENT_LENGTH'};
$agent = $ENV{'HTTP_USER_AGENT'};

if ($con_len == '') {
     print "Content-type: text/html\n\n";
     print "<html><head><title>Table Request...</title></head><body>\n";
     print "<pre><form method=\"post\" action=\"tabhtml.cgi\"><br>\n";
     print "Owner name:  <input type=\"text\" name=\"owner\"><br>\n";
     print "Password:    <input type=\"password\" name=\"passwd\"><br>\n";
     print "Connect:     <input type=\"text\" name=\"connect\"><br>\n";
     print "<input type=\"submit\">   <input type=\"reset\">\n";
     print "</pre></body></html>\n";
} else {
     read(STDIN, $buffer, $con_len);
     @pairs = split(/&/, $buffer);
     foreach $pair (@pairs) {
          ($field, $value) = split(/=/, $pair);
          $value =~ tr/+/ /;
          $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
          $value =~ s/<!--(.|\n)*-->//g;
          $value =~ s/<([^>]|\n)*>//g;
          $FORM{$field}=$value;
     }

     $owner = $FORM{owner};
     $passwd = $FORM{passwd};
     $connect = $FORM{connect};

     ckconnect("$owner/$passwd\@$connect");
     $owner =~ tr/a-z/A-Z/;

     $table_cur = ckcursor(<<EOS);
     select distinct user_tab_columns.table_name, comments
     from user_tab_columns, user_tab_comments
     where user_tab_comments.table_name = user_tab_columns.table_name
     order by user_tab_columns.table_name
EOS

     $item_cur = ckcursor(<<EOS);
     select user_tab_columns.column_name,
            data_type,
            data_length,
            data_precision,
            data_scale,
            data_default,
            comments
     from user_tab_columns, user_col_comments
     where user_tab_columns.table_name = :TABNAME
     and user_col_comments.table_name = user_tab_columns.table_name
     and user_col_comments.column_name = user_tab_columns.column_name
     order by user_tab_columns.column_name
EOS

     print "Content-type: text/html\n\n";
     print "<html><head><title>Table Output: $owner</title></head><body>\n";
     print "<h2>Table structure for $owner</h2>\n";
     print "$dateline<p><pre>\n";
     ckopen($table_cur);
     while (1) {
          (
               $retval,
               $tab_name,
               $tab_comment
          ) = orafetch($table_cur);
          last if $oerr == $ORA_NO_DATA_FOUND;
          bomb ("table cursor") if $retval != $OK;
          print "================================================================\n";
          print "$tab_name\n";
          if ($tab_comment ne '') {
               print "$tab_comment\n";
          }
          print "--------------------  --------  -----  -----  -----  -----------\n";
          print "Column Name           Type        Len   Prec  Scale  Default\n";
          print "--------------------  --------  -----  -----  -----  -----------\n";
          ckbind($item_cur, ":TABNAME", $tab_name);
          ckopen($item_cur);
          while (1) {
               (
                    $retval,
                    $col_name,
                    $type,
                    $length,
                    $precision,
                    $scale,
                    $default,
                    $col_comment
               ) = orafetch($item_cur);
               last if $oerr == $ORA_NO_DATA_FOUND;
               bomb("item cursor") if $retval != $OK;
               printf("%-20.20s  %-8.8s  %5d  %5d  %5d  %-11.11s\n",$col_name, $type, $length, $precision, $scale, $default);
               if ($col_comment ne '') {
                    print "     $col_comment\n\n";
               }
          }
          ckclose($item_cur);
          print "\n";
     }
     ckclose($table_cur);
     ckdisconnect();
     print "</pre></body></html>\n";
}

